<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"> 
<xsl:output method="html"/> 

<xsl:variable name="curLang">DE</xsl:variable>

<xsl:template match="/"> 
<html> 
<body> 
<H1>MSRFMEA XSL Stylesheet. </H1>
<H2>
	<xsl:value-of select="//MSRFMEA/FM-HEAD/COMPANIES/COMPANY/LONG-NAME"/>
</H2>
<HR></HR>

<H3><U>Im Dokument verwendete Sprachen:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/ADMIN-DATA/USED-LANGUAGES/L-10"> 
	<li> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:for-each>
</ul>

<H3><U>Im Dokument enthaltene Personen:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-HEAD/COMPANIES/COMPANY/TEAM-MEMBERS/TEAM-MEMBER/LONG-NAME/L-4"> 
	<li> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:for-each>
</ul>

<H3><U>Fmea-Projekte:</U></H3>
<ol><xsl:for-each select="//MSRFMEA/FM-PROJECTS/FM-PROJECT"> 
	<li> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	<xsl:value-of select="FM-PROJECT"/>
	</li>
	<BR><B>Strukturen:</B></BR>
	<ol>
	<xsl:for-each select="FM-STRUCTURE-REFS/FM-STRUCTURE-REF"> 
		<li>
		<xsl:call-template name="getStructure"> 
		<xsl:with-param name="fm-struc-ref" select="@ID-REF"/>
		</xsl:call-template>
		</li>
	</xsl:for-each>
	</ol>
</xsl:for-each>
</ol>


<H3><U>Fmea-Systemelemente:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-STRUCTURE-ELEMENTS/FM-STRUCTURE-ELEMENT/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Fmea-Funktionstypen:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-FUNCTION-TYPES/FM-FUNCTION-TYPE/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: green</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Fmea-Merkmalstypen:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-CHARACTERISTIC-TYPES/FM-CHARACTERISTIC-TYPE/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: lightblue</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Fmea-Fehlfunktionstypen:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-FAULT-TYPES/FM-FAULT-TYPE/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: red</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Fmea-Betriebszustandstypen:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-OPERATING-CONDITION-TYPES/FM-OPERATING-CONDITION-TYPE/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: brown</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Fmea-Massnahmentypen:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-ACTION-TYPES/FM-ACTION-TYPE/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: grey</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Relation: Systemelemente/Funktionen/Fehlfunktionen/Massnahmen:</U></H3>
<ol><xsl:for-each select="//MSRFMEA/FM-STRUCTURE-ELEMENTS/FM-STRUCTURE-ELEMENT"> 
	<li> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	<xsl:value-of select="FM-STRUCTURE-ELEMENT"/>
	</li>
	<xsl:for-each select="FM-SE-FUNCTIONS/FM-FUNCTION-REF"> 
		<xsl:call-template name="getFunctions"> 
		<xsl:with-param name="fm-func-ref" select="@ID-REF"/>
		</xsl:call-template>
	</xsl:for-each>
	<xsl:for-each select="FM-SE-CHARACTERISTICS/FM-CHARACTERISTIC-REF"> 
		<xsl:call-template name="getCharacteristics"> 
		<xsl:with-param name="fm-func-ref" select="@ID-REF"/>
		</xsl:call-template>
	</xsl:for-each>
	<xsl:for-each select="FM-SE-DECOMPOSITION/FM-STRUCTURE-ELEMENT-REF"> 
		<xsl:call-template name="getStructureElement"> 
		<xsl:with-param name="fm-se-ref" select="@ID-REF"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:for-each>
</ol>

</body>
</html>
</xsl:template>


<xsl:template name="getStructure"> 
<xsl:param name="fm-struc-ref"/> 
<xsl:for-each select="//MSRFMEA/FM-STRUCTURES/FM-STRUCTURE[$fm-struc-ref = @ID]"> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	<xsl:value-of select="FM-STRUCTURE"/>
	<BR><B>Strukturvarianten:</B></BR>
	<xsl:for-each select="FM-VARIANT-REFS/FM-VARIANT-REF"> 
		<xsl:call-template name="getVariant"> 
		<xsl:with-param name="fm-var-ref" select="@ID-REF"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:for-each>
</xsl:template>

<xsl:template name="getVariant"> 
<xsl:param name="fm-var-ref"/> 
<ul><xsl:for-each select="//MSRFMEA/FM-VARIANTS/FM-VARIANT[$fm-var-ref = @ID]"> 
	<li>
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	</li>
</xsl:for-each>
</ul>
</xsl:template>

<xsl:template name="getStructureElement"> 
<xsl:param name="fm-se-ref"/> 
<ul><xsl:for-each select="//MSRFMEA/FM-STRUCTURE-ELEMENTS/FM-STRUCTURE-ELEMENT[$fm-se-ref = @ID]"> 
	<li>
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	</li>
</xsl:for-each>
</ul>
</xsl:template>

<xsl:template name="getFunctions"> 
<xsl:param name="fm-func-ref"/> 
<ul><xsl:for-each select="//MSRFMEA/FM-FUNCTIONS/FM-FUNCTION[$fm-func-ref = @ID]"> 
	<li>
	<xsl:attribute name="style">color: green</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	<xsl:value-of select="FM-FUNCTION"/>
	</li>
	<xsl:for-each select="FM-FAULT-REFS/FM-FAULT-REF"> 
		<xsl:call-template name="getFailures"> 
		<xsl:with-param name="fm-fail-ref" select="@ID-REF"/>
		</xsl:call-template>
	</xsl:for-each>
	<xsl:for-each select="FM-ERROR-DETECTION-REFS/FM-ERROR-DETECTION-REF"> 
		<xsl:call-template name="getErrorDetections"> 
		<xsl:with-param name="fm-ref" select="@ID-REF"/>
		</xsl:call-template>
	</xsl:for-each>
	<xsl:for-each select="FM-ERROR-RESPONSE-REFS/FM-ERROR-RESPONSE-REF"> 
		<xsl:call-template name="getErrorResponss"> 
		<xsl:with-param name="fm-ref" select="@ID-REF"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:for-each>
</ul>
</xsl:template>

<xsl:template name="getCharacteristics"> 
<xsl:param name="fm-func-ref"/> 
<ul><xsl:for-each select="//MSRFMEA/FM-CHARACTERISTICS/FM-CHARACTERISTIC[$fm-func-ref = @ID]"> 
	<li>
	<xsl:attribute name="style">color: lightblue</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	<xsl:value-of select="FM-CHARACTERISTIC"/>
	</li>
	<xsl:for-each select="FM-FAULT-REFS/FM-FAULT-REF"> 
		<xsl:call-template name="getFailures"> 
		<xsl:with-param name="fm-fail-ref" select="@ID-REF"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:for-each>
</ul>
</xsl:template>

<xsl:template name="getFailures"> 
<xsl:param name="fm-fail-ref"/> 
<ul><xsl:for-each select="//MSRFMEA/FM-FAULTS/FM-FAULT[$fm-fail-ref = @ID]"> 
	<li>
	<xsl:attribute name="style">color: red</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	<xsl:value-of select="FM-FAULT"/>
	</li>
	<ul>
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:for-each select="FM-TASK-HISTORY/FM-TASK-SETS"> 		
		<li><xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
			<xsl:value-of select="."/>
		</xsl:for-each>
		- <xsl:value-of select="DATE-1"/></li>
		<xsl:value-of select="FM-TASK-SETS"/>
		<xsl:for-each select="FM-TASK-SET"> 
			<li><xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
				<xsl:value-of select="."/>
			</xsl:for-each></li>
			<xsl:value-of select="FM-TASK-SET"/>
			<xsl:for-each select="FM-OCCURRENCE-TASKS/FM-ACTION-REF"> 
				<xsl:call-template name="getAction"> 
				<xsl:with-param name="fm-action-ref" select="@ID-REF"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:for-each select="FM-DETECTION-TASKS/FM-ACTION-REF"> 
				<xsl:call-template name="getAction"> 
				<xsl:with-param name="fm-action-ref" select="@ID-REF"/>
				</xsl:call-template>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:for-each>
	</ul>
</xsl:for-each>
</ul>
</xsl:template>

<xsl:template name="getAction"> 
<xsl:param name="fm-action-ref"/> 
<ul><xsl:for-each select="//MSRFMEA/FM-ACTIONS/FM-ACTION[$fm-action-ref = @ID]"> 
	<li>
	<xsl:attribute name="style">color: grey</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	- <xsl:value-of select="FM-ACTION-STATE"/>
	</li>
</xsl:for-each>
</ul>
</xsl:template>

<xsl:template name="getErrorDetections"> 
<xsl:param name="fm-ref"/> 
<ul><xsl:for-each select="//MSRFMEA/FM-ERROR-DETECTIONS/FM-ERROR-DETECTION[$fm-ref = @ID]"> 
	<li>
	<xsl:attribute name="style">color: brown</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	</li>
</xsl:for-each>
</ul>
</xsl:template>

<xsl:template name="getErrorResponss"> 
<xsl:param name="fm-ref"/> 
<ul><xsl:for-each select="//MSRFMEA/FM-ERROR-RESPONSS/FM-ERROR-RESPONSE[$fm-ref = @ID]"> 
	<li>
	<xsl:attribute name="style">color: brown</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	</li>
</xsl:for-each>
</ul>
</xsl:template>

</xsl:stylesheet>
